#define BACKGROUND_FILE "bg.pcx"

#include "huc.h"

#define W_DIV_2 127
#define H_DIV_2 131 /* 111 + 20 */
#define FOCALE  16084 /* 16<<8 */

#define COS_FIRST  128
#define COS_SECOND 256
#define COS_THIRD  384
#define COS_FOURTH 512

#define MAX_COORD 20

const int Cube[60]={
 46, 46, 46,
 46,-46, 46,
-46,-46, 46,
-46, 46, 46,
 46, 46,-46,
 46,-46,-46,
-46,-46,-46,
-46, 46,-46,
 46,  0, 46,
  0,-46, 46,
-46,  0, 46,
  0, 46, 46,
 46,  0,-46,
  0,-46,-46,
-46,  0,-46,
  0, 46,-46,
 46, 46,  0,
 46,-46,  0,
-46,-46,  0,
-46, 46,  0
};


/* table des cosinus pour [0,PI/2] (ie) [0,128(inclus)]*/
const int cosSinTable[129]=
{
256,255,255,255,255,255,255,255,254,254,254,253,253,252,252,251,251,
250,249,249,248,247,246,245,244,244,243,242,241,239,238,237,236,
235,234,232,231,230,228,227,225,224,222,221,219,217,216,214,212,
211,209,207,205,203,201,199,197,195,193,191,189,187,185,183,181,
178,176,174,171,169,167,164,162,159,157,155,152,149,147,144,142,
139,136,134,131,128,126,123,120,117,115,112,109,106,103,100,97,
95,92,89,86,83,80,77,74,71,68,65,62,59,56,53,49,
46,43,40,37,34,31,28,25,21,18,15,12,9,6,3,0
};

/*angles de rotations */
int Rx;
int Ry;
int Rz;

/*--------------------------*/
/* Bubble sort              */
/*                          */
/* C'est en O(n*n) mais j'ai*/
/* la flemme de coder le    */
/* quicksort (...)          */
/*--------------------------*/
bubbleSort(tab)
int *tab[];
{
  char i;
  char j;
  char swap;
  int *tmp[];

  for(swap=1, i=MAX_COORD-1; (i > 0)&&(swap); i--)
  {
    swap = 0;

    for(j=0; j<i; j++)
    {
      if(tab[j][2] > tab[j+1][2])
      {
        tmp = tab[j];
        tab[j] = tab[j+1];
        tab[j+1] = tmp;

        swap = 1;
      }
    }
  }
}

/*--------------------------*/
/* fake cosinus             */
/*--------------------------*/
cos(val, result)
int val, *result;
{
  if(val > COS_FOURTH)
    val = val - COS_FOURTH;
  
  if(val <= COS_FIRST)
  {
    *result = cosSinTable[val];
    return;
  } 
                  
  if(val <= COS_SECOND)
  {
    *result = -cosSinTable[COS_SECOND - val];
    return;
  }  

  if(val <= COS_THIRD)
  {  
    *result = -cosSinTable[val - COS_SECOND];
    return;
  }  

  *result = cosSinTable[COS_FOURTH - val];      
}



/*--------------------------*/
/* fake sinus               */
/*--------------------------*/
sin(val, result)
int val, *result;
{
  if(val <= COS_FIRST)
    *result = cosSinTable[COS_FIRST - val];
  else  
    if(val <= COS_SECOND)
      *result = cosSinTable[val - COS_FIRST];
    else
      if(val <= COS_THIRD)
        *result = -cosSinTable[COS_THIRD - val];
      else
          *result = -cosSinTable[val - COS_THIRD];      
}


/*--------------------------*/
/* fake XYZ rotation        */
/*--------------------------*/
rotate(x,y,z)
int *x, *y, *z;
{
 int cx, cy, cz;
 int sx, sy, sz;

 int tmpX, tmpY, tmpZ;

 Rx &= 511;
 Ry &= 511;
 Rz &= 511;

 cos(Rx,&cx);
 cos(Ry,&cy);
 cos(Rz,&cz);

 sin(Rx,&sx);
 sin(Ry,&sy);
 sin(Rz,&sz);

 tmpX = (*x * cz) + (*y * sz);
 tmpY = (*x * sz) - (*y * cz);

 *x = tmpX>>8;
 *y = tmpY>>8;

 tmpX = (*x * cy) + (*z * sy);
 tmpZ = (*x * sy) - (*z * cy);

 *x = tmpX>>8;
 *z = tmpZ>>8;

 tmpZ = (*z * cx) + (*y * sx);
 tmpY = (*z * sx) - (*y * cx);

 *z = tmpZ>>8;
 *y = tmpY>>8;
}

main()
{
 char i;
 int j;

 int *obj;

 int tmpObj[60];
 int *tmp;

 int *addr[MAX_COORD];
 int *tmpAddr[];

 int xCurr, yCurr, zCurr;

 char zView;
 int persp;

 Rx = 0;
 Ry = 0;
 Rz = 0;

 zView = 116;

 load_sprites(0x7000, ball, 1);

 init_satb();

 for(i=0; i<MAX_COORD; i++)
 {
   spr_set(i);
   spr_pattern(0x7000);
   spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);
   spr_pal(0);
   spr_pri(1);
 }

 load_background(bgPix, bgPal, bgBat, 32,28);

 vsync(1);

 set_sprpal(0,ballColor);

 for(;;)
 {
   vsync();

   for(i=0, obj=Cube, tmp=tmpObj, tmpAddr=addr; i<MAX_COORD; i++, obj+=3)
   {
     *(tmpAddr++) = tmp;

     xCurr = *obj;
     yCurr = *(obj + 1);
     zCurr = *(obj + 2);

     rotate(&xCurr, &yCurr, &zCurr);

     zCurr = zCurr + zView;

     if(zCurr > 0)
     {
       persp = FOCALE / zCurr;

       xCurr = W_DIV_2 + ((xCurr * persp) >> 8);
       yCurr = H_DIV_2 + ((yCurr * persp) >> 8);

     }
     else
     {
        xCurr = W_DIV_2 + ((xCurr * FOCALE) >> 8);
        yCurr = H_DIV_2 + ((yCurr * FOCALE) >> 8);
     }

     *(tmp++) = xCurr;
     *(tmp++) = yCurr;
     *(tmp++) = zCurr;
   }

   bubbleSort(addr);

   for(i=0, tmpAddr=addr; i<MAX_COORD; i++, tmpAddr++)
   {
     spr_set(i);
     spr_x((*tmpAddr)[0]);
     spr_y((*tmpAddr)[1]);
   }

   Rx+=10;
   Ry+=10;

   satb_update();
 }
}

#incspr(ball,"ball2.pcx",0,0,1,1);
#incpal(ballColor,"ball2.pcx",0,1);

#incchr(bgPix,BACKGROUND_FILE,32,28);
#incpal(bgPal,BACKGROUND_FILE);
#incbat(bgBat,BACKGROUND_FILE,0x1000,32,28);

